Generic Image Library: any_image_view< ImageViewTypes > Class Template Reference

###  | #  |

- Main Page
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | List of all members
any_image_view< ImageViewTypes > Class Template Reference
Models

Represents a run-time specified image view. Models HasDynamicXStepTypeConcept, HasDynamicYStepTypeConcept, Note that this class does NOT model ImageViewConcept. More...

`#include <any_image_view.hpp>`

Inheritance diagram for any_image_view< ImageViewTypes >:

## Public Types
typedef any_image_view < typename detail::views_get_const_t < ImageViewTypes >::type > | const_t
typedef std::ptrdiff_t | x_coord_t
typedef std::ptrdiff_t | y_coord_t
typedef point2< std::ptrdiff_t > | point_t
Public Types inherited from variant< ImageViewTypes >
typedef ImageViewTypes | types_t

## Public Member Functions
template<typename T >
| any_image_view (const T &obj)
| any_image_view (const any_image_view &v)
template<typename Types >
| any_image_view (const any_image_view< Types > &v)
template<typename T >
any_image_view & | operator= (const T &obj)
any_image_view & | operator= (const any_image_view &v)
template<typename Types >
any_image_view & | operator= (const any_image_view< Types > &v)
std::size_t | num_channels () const
point_t | dimensions () const
x_coord_t | width () const
y_coord_t | height () const
Public Member Functions inherited from variant< ImageViewTypes >
| variant (const T &obj)
| variant (const variant< Types2 > &obj)
| variant (T &obj, bool do_swap)
| variant (const variant &v)
variant & | operator= (const T &obj)
variant & | operator= (const variant &v)
void | move_in (T &obj)
const T & | _dynamic_cast () const
T & | _dynamic_cast ()
bool | current_type_is () const
base_t | bits () const
std::size_t | index () const

## Additional Inherited Members
Static Public Member Functions inherited from variant< ImageViewTypes >
static bool | has_type ()

## Detailed Description

### template<typename ImageViewTypes>
class boost::gil::any_image_view< ImageViewTypes >

Represents a run-time specified image view. Models HasDynamicXStepTypeConcept, HasDynamicYStepTypeConcept, Note that this class does NOT model ImageViewConcept.

CLASS any_image_view

Represents a view whose type (color space, layout, planar/interleaved organization, etc) can be specified at run time. It is the runtime equivalent of `image_view`. Some of the requirements of ImageViewConcept, such as the `value_type` typedef cannot be fulfilled, since the language does not allow runtime type specification. Other requirements, such as access to the pixels, would be inefficient to provide. Thus `any_image_view` does not fully model ImageViewConcept. However, many algorithms provide overloads taking runtime specified views and thus in many cases `any_image_view` can be used in places taking a view.

To perform an algorithm on any_image_view, put the algorithm in a function object and invoke it by calling `apply_operation(runtime_view, algorithm_fn)`;

The documentation for this class was generated from the following file:

- any_image_view.hpp